package org.apache.bcel.generic;

import java.io.DataOutputStream;
import java.io.IOException;

/* loaded from: org_apache_bcel_generic.jar:org/apache/bcel/generic/JSR.class */
public class JSR extends JsrInstruction implements VariableLengthInstruction {
    /* JADX INFO: Access modifiers changed from: package-private */
    public JSR() {
    }

    public JSR(InstructionHandle target) {
        super((short) 168, target);
    }

    @Override // org.apache.bcel.generic.Instruction
    public void accept(Visitor v) {
        v.visitStackProducer(this);
        v.visitVariableLengthInstruction(this);
        v.visitBranchInstruction(this);
        v.visitJsrInstruction(this);
        v.visitJSR(this);
    }

    @Override // org.apache.bcel.generic.BranchInstruction, org.apache.bcel.generic.Instruction
    public void dump(DataOutputStream out) throws IOException {
        super.setIndex(getTargetOffset());
        if (super.getOpcode() == 168) {
            super.dump(out);
            return;
        }
        super.setIndex(getTargetOffset());
        out.writeByte(super.getOpcode());
        out.writeInt(super.getIndex());
    }

    /* JADX INFO: Access modifiers changed from: protected */
    @Override // org.apache.bcel.generic.BranchInstruction
    public int updatePosition(int offset, int maxOffset) {
        int i = getTargetOffset();
        setPosition(getPosition() + offset);
        if (Math.abs(i) >= 32767 - maxOffset) {
            super.setOpcode((short) 201);
            short oldLength = (short) super.getLength();
            super.setLength(5);
            return super.getLength() - oldLength;
        }
        return 0;
    }
}
